/*
** main.c
**
** Nokia 3310 Example Program
** Target: ATMEGA :: AVR-GCC
**
** Written by Tony Myatt - 2007
** Quantum Torque - www.quantumtorque.com
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "lcd.h"


/*macro-uri pt butoane*/
#define LEFT_BUTTON (PINB & (1<<PB0))
#define CENTER_BUTTON (PINB & (1<<PB4))
#define RIGHT_BUTTON (PINB & (1<<PB1))

/* main -- Program starts here */
int main(void)
{	
	unsigned char i,j,k,piesa=2;
	unsigned char x_curent,y_curent;
	unsigned char rez;
	unsigned char stop_joc=0;
	unsigned char scor1,scor2;
	// Setup LCD
	lcd_init();
	lcd_contrast(0x40);
	//initializare butoane
	buttons_init();
	
	lcd_goto_xy(1,1);
	lcd_str("<<tetris>>");
	lcd_goto_xy(1,3);
	lcd_str("Press center");
	lcd_goto_xy(1,4);
	lcd_str("button to");
	lcd_goto_xy(1,5);
	lcd_str("start");

	while(1){
		while(CENTER_BUTTON);	
		lcd_clear();

	
		board_init();
		init_data();
		stop_joc=0;
		scor1=-1;scor2=0;
		while(!stop_joc){
			scor1++;
			if(scor1==10){
				scor1=0;
				scor2++;
			}
			lcd_goto_xy(80,2);
			lcd_str("score:");
			lcd_goto_xy(80,3);
			lcd_chr(scor2+'0');
			lcd_chr(scor1+'0');	
			piesa++;
			if(piesa==5)
				piesa=0;
			x_curent=1;y_curent=40;
			switch(piesa){
				case 0:
					//square
					draw_square(1,40,1);
					break;
				case 1:
					//vert_line
					draw_vertical_line(1,40,1);
					break;
				case 2:
					//horiz_line
					draw_horizontal_line(1,40,1);
					break;
				case 3:
					draw_L_up(1,40,1);
					break;
				case 4:
					draw_L_down(1,40,1);
					break;
			}
			unsigned char gata=0;//piesa e pe poz finala
			while(!gata){
				if(LEFT_BUTTON==0){
					_delay_ms(2000);
					rez=deplasare_stanga(piesa,x_curent,y_curent);
					if(rez)
						y_curent-=4;//deplasarea a fost posibila	
				}
				if(RIGHT_BUTTON==0){
					_delay_ms(2000);
					rez=deplasare_dreapta(piesa,x_curent,y_curent);
					if(rez)
						y_curent+=4;//deplasarea a fost posibila	
				}
				if( CENTER_BUTTON ==0){
					//rotire
					_delay_ms(2000);
					piesa=rotire(piesa,x_curent,y_curent);	
				}
				_delay_ms(2000);
				rez=deplasare_jos(piesa,x_curent,y_curent);
				x_curent+=4;
				if(rez==2)
					stop_joc=1;
				else gata=rez;				
				if(stop_joc)									
					break;
			}
		}
		
		lcd_clear();
		lcd_goto_xy(2,2);
		lcd_str("game over");
		
		lcd_goto_xy(2,3);
		lcd_str("score:");
		lcd_chr (scor2+'0');
		lcd_chr(scor1+'0');	
		
		lcd_goto_xy(2,5);
		lcd_str("press center ");
		lcd_goto_xy(4,6);
		lcd_str("to start");
		lcd_goto_xy(5,7);
		lcd_str("again");
		
	}


}
